/*  This is a short program demonstrating the _fcopy function.  It
    prompts the user for source and target filenames and then performs
    the copy.  If an error occurred during the copy operation, an error
    message is displayed.

    Written by Ray Waters */

#include <io.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "fcopy.h"

main()
{
    char SrcName[80];                   /* buffer for source filename */
    char DestName[80];                  /* buffer for target filename */
    register int count = 0;
    int InputError;

    printf("\nDemonstration of _fcopy function:\n");

    do {
        printf("\n  Enter the SOURCE file name:  ");
        gets(SrcName);                      /* get source filename */

        InputError = access(SrcName, 0);    /* see if source exists */
        if (InputError) {
            count++;
            if (count > 2) {                /* give them up to 3 tries */
                fprintf(stderr, "\nToo many input errors.  "
                                  "Returning to DOS.\n");
                return -1;
            }
            perror("\nINPUT ERROR");        /* if not, display error */
        }
    }
    while (InputError);                     /* and try again */
    strupr(SrcName);                        /* fold to upper case */

    printf("\n  Enter the TARGET file name:  ");
    gets(DestName);                         /* get target filename */
    strupr(DestName);                       /* fold to upper case */

    if (!_fcopy(SrcName, DestName)) {       /* perform the file copy */
                                            /* if successful, */
        printf("\nSUCCESS: Copied %s to %s\n", SrcName, DestName);
        return 0;                           /* exit */
    }

    switch (errno) {        /* on error, display appropriate message */
        case -1:
            fprintf(stderr, "\nFCOPY ERROR: Target disk full\n");
            break;
        default:                    /* message depends upon errno */
            perror("\nFCOPY ERROR");
            break;
    }
    if (!remove(DestName))           /* try to delete bad target file */
        printf("Target file %s deleted\n", DestName);

    return -1;                              /* exit */
}
